require "mod_baby/version"

module ModBaby

  class Ratio 
    attr_reader :name, :value

    def initialize(name, value)
      @name = name
      @value = value
    end

    def steps(base)
      (base * @value)
    end
  end

  Ratios = [
    Ratio.new("Golden Ratio", 1.618),
    Ratio.new("Perfect Fourth", 1.333),
    Ratio.new("Perfect Fifth", 1.5),
    Ratio.new("Major Third", 1.25),
    Ratio.new("Minor Third", 1.2),
    Ratio.new("Octave", 2),
    Ratio.new("Double Octave", 4)
  ]

  class Choices 
    def self.list
      choices = []
      Ratios.each_with_index do |choice, i|
        choices << "#{i+1}. #{choice.name}"
      end
      return choices.join("\n")
    end
  end

  class ModularScale
    def self.calculate_scale(base, ratio_choice)
      ratio = Ratios[ratio_choice - 1]
      results = {base => 1}
      ems = 1

      6.times do
        base = ratio.steps(base).round(3)
        ems = ratio.steps(ems).round(3)
        results[base] = ems
      end
      return results
    end
  end
end
